36.12 Хеш-функции
Часто бывает необходимо выяснить, идентичны ли две строки или два файла. Это можно сделать, сравнив их посимвольно и найдя различия. Однако это может быть медленно, поэтому сравнение хешей строк или файлов может стать быстрым способом определить, отличаются ли файлы.
Ещё одно применение хеш-функции — проверка целостности файла. Пользователь может сравнить хеш файла с известным значением и выяснить, совпадает ли имеющийся у него файл с тем, для которого был получен исходный хеш.
Octave предоставляет функцию hash для вычисления хеш-значений строк и файлов; для файлов она используется в сочетании с функцией fileread. Функция hash поддерживает множество широко используемых методов хеширования.
-
:
hashval =hash("hashfcn", str) -
Вычисляет хеш-значение строки str с помощью хеш-функции hashfcn.
Доступные хеш-функции приведены в таблице ниже.
- ‘MD2’
-
Алгоритм хеширования сообщений 2 (RFC 1319).
- ‘MD4’
-
Алгоритм хеширования сообщений 4 (RFC 1320).
- ‘MD5’
-
Алгоритм хеширования сообщений 5 (RFC 1321).
- ‘SHA1’
-
Алгоритм безопасного хеширования 1 (RFC 3174)
- ‘SHA224’
-
Алгоритм безопасного хеширования 2 (224 бита, RFC 3874)
- ‘SHA256’
-
Алгоритм безопасного хеширования 2 (256 бит, RFC 6234)
- ‘SHA384’
-
Алгоритм безопасного хеширования 2 (384 бита, RFC 6234)
- ‘SHA512’
Алгоритм безопасного хеширования 2 (512 бит, RFC 6234)
Например, чтобы вычислить хеш-значение MD5 строки
"abc", функциюhashвызывают следующим образом:hash ("md5", "abc") -| ans = 900150983cd24fb0d6963f7d28e17f72Для той же строки хеш-значение SHA-1 вычисляется так:
hash ("sha1", "abc") -| ans = a9993e364706816aba3e25717850c26c9cd0d89dА чтобы вычислить хеш-значение файла, например
file = "file.txt", вызовитеhashв сочетании сfileread:hash ("md5", fileread (file));
© 1996–2026 The Octave Project Developers
Permission is granted to make and distribute verbatim copies of this manual provided the copyright notice and this permission notice are preserved on all copies.
Permission is granted to copy and distribute modified versions of this manual under the conditions for verbatim copying, provided that the entire resulting derived work is distributed under the terms of a permission notice identical to this one.Permission is granted to copy and distribute translations of this manual into another language, under the above conditions for modified versions.
https://docs.octave.org/v9.4.0/Hashing-Functions.html